Attribute VB_Name = "DNSProv"
Option Explicit
'********************************************************************
'*              ---   Web Admin - DNS Service   ---
'*
'* Created By:  Ed Tremblay 11/10/2000
'*
'*
'*
'* For this routine to run correctly the WMI DNS provider must be loaded on the server
'* that these web pages will run on.
'*
'* For this routine to work properly the DNS service need to be runnin on a Windows 2000
'* DNS Server.
'*
'* Location of the DNS provider - ftp.microsoft.com/reskit/win2000/dnsprov.zip
'*
'* To install the dns provider,
'* 1. Copy dnsschema.mof and dnsprov.dll to <winntdir>\system32\wbem.
'* 2. Run "mofcomp dnsschema.mof" to register the class information.
'* 3. Run "regsvr32 dnsprov.dll" to register the dll.



'********************************************************************
'*
'* Sub DnsZoneCreate()
'*
'* Purpose: Creates a Zone.
'*
'* Input:   sDNSServer           a machine name for the DNS server
'*
'*          sDNSZoneType         type of zone to create (Primary, ADIntegrated, etc.
'*          sDNSZoneName         name of DNS zone ("foobar.com")
'*          strPropertyArray     The job to perform
'*
'* Output:  Results are either printed on screen or saved in strOutputFile.
'*
'********************************************************************

Function DnsZoneCreate(sDNSservername, _
                      sDNSZoneType, _
                      sDNSZoneName)
                      
    On Error GoTo ErrorHandler

    Dim objFileSystem, objOutputFile, objService, objDnsSet, objServer, objInst
    Dim sUserName, sPassword
    Dim strPropertyArray()
    ReDim strPropertyArray(20)


    'Establish a connection with the server. exit function on error
    ' true indicates error in binding to wmi and the dns provider
    If blnConnect("root\microsoftdns", _
                   sUserName, _
                   sPassword, _
                   sDNSservername, _
                   objService) Then
        Exit Function
    End If

    Set objServer = objService.Get("MicrosoftDNS_Server.name="".""")
    Set objDnsSet = objService.Get("MicrosoftDNS_ZONE")
     
    '//strPropertyArray(0) = "0" '//dsintegrated zone
    '//strPropertyArray(0) = "1" '//Primary zone
    '//strPropertyArray(0) = "2" '//Secondary zone
    '//strPropertyArray(2) = name of primary zone
    '//
    '//example - "myzone.com" for primary or "0.0.10.in-addr.arpa" for a
    '//           reverse zone for ip address 10.0.0.2
    

    strPropertyArray(0) = sDNSZoneType
    strPropertyArray(2) = sDNSZoneName
    objInst = objDnsSet.CreateZone(strPropertyArray(2), strPropertyArray(0))
    
    Set objServer = Nothing
    Set objService = Nothing
    Set objDnsSet = Nothing
    Set objService = Nothing
    Set objInst = Nothing

Exit Function

ErrorHandler:

    If Err.Number <> -2147217407 Then '//-2147217407 = generic failure which indicates an
                                      '//existing zone. In this case do not display a message
       Call MsgBox(Err.Description & " " & CStr(Err.Number), vbInformation, App.Title & " Error")
    End If
    

    Set objServer = Nothing
    Set objService = Nothing
    Set objDnsSet = Nothing
    Set objService = Nothing
    Set objInst = Nothing
    
End Function

'********************************************************************
'*
'* Sub DnsRecordCreate()
'*
'* Purpose: Creates DNS records (A, MX Cname, etc.).
'*
'* Input:   strServer           a machine name
'*          strOutputFile       an output file name
'*          strUserName         the current user's name
'*          strPassword         the current user's password
'*          Cresource             The job to perform
'*
'* Output:  Results are either printed on screen or saved in strOutputFile.
'*
'********************************************************************
Function DnsRecordCreate(sDNSParentName, _
                        sDNSIPAddr, _
                        sDNSservername, _
                        sDNSMailservername, _
                        sDNSMXPriority, _
                        sDNSMailDomain, _
                        sDNSRecordType)

  On Error GoTo ErrorHandler
    
    Dim objFileSystem As Object, objDns As Object
    Dim objService As Object, objServer As Object
    Dim objMethod As Object, objInParam As Object, objOutParam As Object
    Dim sRecordCreate As String
    Dim sUserName As String
    Dim sPassword As String
    Dim sServer As String
    
    Const MX_DNS_RECORD_TYPE = "MX"
    Const A_DNS_RECORD_TYPE = "A"
 
    
     'Establish a connection with the server.
    If blnConnect("root\microsoftdns", _
                   sUserName, _
                   sPassword, _
                   sDNSservername, _
                   objService) Then
        Exit Function
    End If

  
    Set objDns = objService.Get("MicrosoftDNS_ResourceRecord")
    Set objServer = objService.Get("MicrosoftDNS_Server.Name="".""")
    Set objMethod = objDns.Methods_("CreateInstanceFromTextRepresentation")
    Set objInParam = objMethod.inParameters.SpawnInstance_()
        

    Select Case sDNSRecordType
                Case MX_DNS_RECORD_TYPE
                    sRecordCreate = sDNSMailDomain
                    sRecordCreate = sRecordCreate & "." & sDNSParentName
                    sRecordCreate = sRecordCreate & " IN "
                    sRecordCreate = sRecordCreate & sDNSRecordType & " "
                    sRecordCreate = sRecordCreate & sDNSMXPriority & " "
                    sRecordCreate = sRecordCreate & sDNSMailservername & "." & sDNSParentName
                    objInParam.TextRepresentation = sRecordCreate
                    
                    '//cool1.Com IN MX  10 zMail.mailtest.Com
                    '//objInParam.TextRepresentation = "mailtest.Com IN MX 10 MailSvr"
                Case A_DNS_RECORD_TYPE
                     sRecordCreate = sDNSMailservername & "."
                     sRecordCreate = sRecordCreate & sDNSParentName
                     sRecordCreate = sRecordCreate & " IN "
                     sRecordCreate = sRecordCreate & sDNSRecordType & " "
                     sRecordCreate = sRecordCreate & sDNSIPAddr
                     objInParam.TextRepresentation = sRecordCreate
                    '//objInParam.TextRepresentation = "axz92.cool1.com IN A 10.10.10.98"
                Case Else
                    '/ set error message
                    Exit Function
    End Select
    
    objInParam.DnsServerName = objServer.Name
    objInParam.ContainerName = CStr(sDNSParentName)
        
    
    Set objOutParam = objDns.ExecMethod_("CreateInstanceFromTextRepresentation", objInParam)

    
    Set objServer = Nothing
    Set objService = Nothing
    Set objDns = Nothing
    Set objMethod = Nothing
    Set objInParam = Nothing

Exit Function

ErrorHandler:

    If Err.Number <> -2147217407 Then '//-2147217407 = generic failure which proably indicates an
                                      '//existing DNS record. In this case do not display a message
       Call MsgBox(Err.Description & " " & CStr(Err.Number), vbInformation, App.Title & " Error")
    End If
    

    
    Set objServer = Nothing
    Set objService = Nothing
    Set objDns = Nothing
    Set objMethod = Nothing
    Set objInParam = Nothing
    
End Function

'********************************************************************
'*
'* Function blnConnect()
'*
'* Purpose: Connects to machine sDNSserver.
'*
'* Input:   sDNSserver       a machine name
'*          strNameSpace    a namespace
'*          sUserName     name of the current user
'*          sPassword     password of the current user
'*
'* Output:  objService is returned  as a service object.
'*          sDNSserver is set to local host if left unspecified
'*
'********************************************************************
Function blnConnect(ByVal strNameSpace, _
                            ByVal sUserName, _
                            ByVal sPassword, _
                            ByRef sDNSserver, _
                            ByRef objService)

  On Error GoTo ErrorHandler

    Dim objLocator, objWshNet
    
    blnConnect = False     'There is no error.

    'Create Locator object to connect to remote CIM object manager
    Set objLocator = CreateObject("WbemScripting.SWbemLocator")
    

    'Connect to the namespace which is either local or remote
    Set objService = objLocator.ConnectServer(sDNSserver, strNameSpace, _
       sUserName, sPassword)
    objService.Security_.impersonationlevel = 3
    
    Set objLocator = Nothing
    
Exit Function

ErrorHandler:

    Call MsgBox(Err.Description & " " & CStr(Err.Number), vbInformation, App.Title & " Error")
    blnConnect = 1
    
    Set objService = Nothing
    
End Function

Function DnsRecordDelete(sDNSParentName, _
                            sDNSservername, _
                            sDNSMailservername, _
                            sDNSMXPriority, _
                            sDNSMXname)
  On Error GoTo ErrorHandler
 
     

    Dim sRecordCreate As String
    Dim sUserName As String
    Dim sPassword As String
    Dim sServer As String
    Dim objService As Object
    Dim objDns As Object
    

    
    'Establish a connection with the server.
    If blnConnect("root\microsoftdns", _
                   sUserName, _
                   sPassword, _
                   sDNSservername, _
                   objService) Then
        Exit Function
    End If
   
    
    '//MicrosoftDNS_MXType.ContainerName="ab.com",DnsServerName="asp-ad-01.edhost.com",
    '//DomainName="ab.com",OwnerName="mmm.ab.com",RecordClass=1,RecordData=" 10 asp-exch-01."
    
    '//sRecordCreate = "MicrosoftDNS_MXType.ContainerName="
    '//sRecordCreate = sRecordCreate & """" & sDNSParentName & """" & ","
    '//sRecordCreate = sRecordCreate & "DnsServerName=" & """" & sDNSservername & """" & ","
    '//sRecordCreate = sRecordCreate & "DomainName=" & """" & sDNSParentName & """" & ","
    '//sRecordCreate = sRecordCreate & "OwnerName=" & """" & sDNSMXname & "." & sDNSParentName & """" & ","
    '//sRecordCreate = sRecordCreate & "RecordClass=1,RecordData=" & """" & " " & sDNSMXPriority & " " & sDNSMailservername & "." & """"

    '//MicrosoftDNS_MXType.ContainerName="ab.com",DnsServerName="asp-ad-01.edhost.com",
    '//DomainName="ab.com",OwnerName="Cust2.ab.com",RecordClass=1,RecordData=" 10 asp-exch-01.ab.com."
    
    sRecordCreate = "MicrosoftDNS_MXType.ContainerName="
    sRecordCreate = sRecordCreate & """" & sDNSParentName & """" & ","
    sRecordCreate = sRecordCreate & "DnsServerName=" & """" & sDNSservername & """" & ","
    sRecordCreate = sRecordCreate & "DomainName=" & """" & sDNSParentName & """" & ","
    sRecordCreate = sRecordCreate & "OwnerName=" & """" & sDNSMXname & "." & sDNSParentName & """" & ","
    sRecordCreate = sRecordCreate & "RecordClass=1,RecordData=" & """" & " " & sDNSMXPriority & " " & sDNSMailservername & "." & sDNSParentName & "." & """"
    
    Set objDns = objService.Get(sRecordCreate)
    objDns.Delete_

    Exit Function
    
ErrorHandler:

    Call MsgBox(Err.Description & " " & CStr(Err.Number), vbInformation, App.Title & " Error")

    
    Set objService = Nothing
    Set objService = Nothing
    Set objDns = Nothing
    
End Function

