Attribute VB_Name = "ExchangeProv"
Option Explicit

Const HOSTING_OU = "Hosting"
Const SERVICES_OU = "Services"

Const MASTER_GROUP_ALLUSERS = "AllUsersGroup"
Const MASTER_GROUP_ALLADMINS = "AllAdminsGroup"
Const MASTER_GROUP_ALLADVUSERS = "AllAdvancedUsersGroup"
Const MASTER_GROUP_ALLNORMAL = "AllNormalUsersGroup"
Const MASTER_GROUP_ALLMULTIORGADMIN = "AllMultiOrgAdminsGroup"
Const MASTER_GROUP_EXCH_ADMINS = "ExchAdmins"
Const MASTER_GROUP_EXCH_MAILBOX = "ExchMailboxManagers"

Const constNORMAL_USER_GROUP = "NormalUsers@"
Const constADVANCED_USER_GROUP = "AdvancedUsers@"
Const constALL_USERS_GROUP = "AllUsers@"
Const constADMINS_GROUP = "Admins@"
Const constMULTIORGADMIN_GROUP = "MultiOrgAdmin@"


'* Set Public Constants
Const SE_DACL_PROTECTED = &H1000
Const SE_SACL_PROTECTED = &H2000
Const USE_SPECIFIC_DOMAIN = ""
Const ASP_SERVICES_ENABLED = True
Const Write_Debug = False
Const PREFERED_OAB_EXCH_SERVER = ""
'*
'* ******************Public Variables ************************

Dim ResultArrayCounter
Dim SearchArrayItems()
Dim ArrayCounter
Dim oTempRecipientPolicy, oTempGetExchangeServerList

' Set the Size of the Array for use in GetRecipientPolicyContainer()
Dim ResultArrayItems(5)
Dim oUserObj As IADs
Dim oDefaultPolicy As Object
Dim DFsystemFlags, DFdisabledGatewayProxy, DFmsExchPolicyOptionList, DFGatewayProxy
Dim DFpurportedSearch, DFmsExchpolicyOrder, DFmsExchProxyGenOptions

Dim sAdsPath As String

'********************************************************************
'*              ---   Exchange Prov   ---
'*
'* Created By: Conrad Agramont & Ed Tremblay
'*
'* sets up recipient policies and global address lists when OUs are created
'*
'*
'* Notes:
'*          - Any Items marked optional with [braces] need to have a
'*              blank string passed into the function.
'*
'*          - Main.asp and Utils.asp libraries need to be called from
'*              the calling ASP Page for this library.
'*
'********************************************************************

'
'*
'********************************************************************
Public Function ProvExch(oOu, oDefaultPolicy)

Dim lRet As Long

Dim oRecipientPolicyCont As Object



'//get the recipient policy container
'//Set oDefaultPolicy = GetPolicyByName("CN=Default Policy")

DFsystemFlags = oDefaultPolicy.systemFlags
DFdisabledGatewayProxy = oDefaultPolicy.disabledGatewayProxy
DFmsExchPolicyOptionList = oDefaultPolicy.msExchPolicyOptionList
DFGatewayProxy = oDefaultPolicy.gatewayproxy

' Get the Recipient Policy Container from AD (In Config Container)
Set oRecipientPolicyCont = GetRecipientPolicyContainer()


'//sAdsPath = "LDAP://OU=Cust1,OU=Hosting,DC=edhost,DC=com"
'//Set oUserObj = GetObject(sAdsPath)
lRet = NewOrgProvisionExchange(oOu, oRecipientPolicyCont)

'//need error handling logging here


Set oRecipientPolicyCont = Nothing
'//Set oDefaultPolicy = Nothing

End Function


'********************************************************************
'*
'* Function NewOrgProvisionExchange(oOuObj, oDefaultPolicy)
'* Purpose: Provision Exchange 2000 Services for an Organization.
'* Input:       oOuObj          Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function NewOrgProvisionExchange(oOu, oRecipientPolicyCont)
On Error Resume Next


    Dim AllUsersGroupName, AdminsGroupName
    Dim AllUsersAdsPath, AdminsAdsPath
    Dim lRet As Long
    
    
    ' Create the Recipient Policy for the Org
    lRet = CreateRecipientPolicy(oOu, oRecipientPolicyCont)
        If Err.Number <> 0 Then
            WriteLog "CreateRecipientPolicy", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: NewOrgProvisionExchange()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
            ' Need Roll Back Routine
            Exit Function
        End If
    
    
    lRet = CreateGroupRecipientPolicy(oOu, oRecipientPolicyCont)
        If Err.Number <> 0 Then
            WriteLog "CreateGroupRecipientPolicy", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: NewOrgProvisionExchange()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
            ' Need Roll Back Routine
            Exit Function
        End If
    
    '//Create the Global Address List for the Org
    lRet = CreateGAL(oOu)
        If Err.Number <> 0 Then
            WriteLog "CreateGAL", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: NewOrgProvisionExchange()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
                ' Need Roll Back Routine
            Exit Function
        End If
    
    ' Get the Info needed to mail enable groups
   
    AllUsersGroupName = constALL_USERS_GROUP & GetRootOU(oOu.ADsPath)
    AllUsersAdsPath = "LDAP://CN=" & AllUsersGroupName & "," & CleanOutProtocol(oOu.ADsPath)
    
    
    ' Mail Enable Groups
    MailEnableGrp AllUsersAdsPath, AllUsersGroupName, ParseUsername(AllUsersGroupName)
        If Err.Number <> 0 Then
            WriteLog "MailEnableGroup", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: NewOrgProvisionExchange()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
                ' Need Roll Back Routine
            Exit Function
        End If
    
    ' If we get to this point, then all went well.
    
    '//List1.AddItem "NewOrgProvisionExchange " & "Org: " & GetRootOU(oOuObj.ADsPath)
    
    
End Function

'********************************************************************
'*
'* Function OrgDeleteExchangeObjects(oOuObj, oDefaultPolicy)
'* Purpose: delete Provisioned Exchange 2000 Services for an Organization.
'* Input:       oOuObj  oDefaultPolicy        Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function OrgDeleteExchangeObjects(oOu)
On Error Resume Next
    Dim tempOuAdsPath, AllUsersGroupName, AdminsGroupName
    Dim AllUsersAdsPath, AdminsAdsPath
    Dim sType As String
    Dim lRet As Integer
    

    ' Create the Recipient Policy for the Org
    sType = " - user"
    lRet = DeleteRecipientPolicy(oOu, sType)
        If Err.Number <> 0 Then
            WriteLog "DeleteRecipientPolicy", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: OrgDeleteExchangeObjects()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
            Exit Function
        End If
        
     sType = " - group"
     lRet = DeleteRecipientPolicy(oOu, sType)
        If Err.Number <> 0 Then
            WriteLog "DeleteRecipientPolicy", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: OrgDeleteExchangeObjects()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
            Exit Function
        End If
    
    ' Create the Global Address List for the Org

     lRet = DeleteGAL(oOu)
        If Err.Number <> 0 Then
          WriteLog "DeleteGAL", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: OrgDeleteExchangeObjects()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
          Exit Function
        End If
    
    
    ' If we get to this point, then all went well.
    WriteLog "Delete - OrgProvisionExchange", 0, "Org: " & GetRootOU(oOu.ADsPath)
    
    
End Function
'********************************************************************
'*
'* Function CreateRecipientPolicy(oOuObj)
'* Purpose: Create a Recipient Policy for an Organization
'* Input:       oOuObj          Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function CreateRecipientPolicy(oOu, oRecipientPolicyCont)
'On Error Resume Next
    
    
Dim newPurportedSearch, newGatewayProxy, newMsExchpolicyOrder, newMsExchProxyGenOptions
Dim RootOUName, NewPolicy
        
    
    '*****************************************************************
    ' Begin Creation of the new Recipient Policy
    
    ' Get Root OU Name
    RootOUName = GetRootOU(oOu.ADsPath)
    
    ' Create the Purported Search Filter
    newPurportedSearch = _
        "(&(&(&(|(&(objectCategory=person)(objectSid=*)" & _
        "(!samAccountType:1.2.840.113556.1.4.804:=3))" & _
        "(&(objectCategory=person)(!objectSid=*))" & _
        "(&(objectCategory=group)" & _
        "(groupType:1.2.840.113556.1.4.804:=14))))" & _
        "(objectCategory=user)(mailNickname=*)(userPrincipalName=*@" & RootOUName & ")))"
    
    'Create msExchPurportedSearchUI Array
    Dim tempmsExchPurportedSearcyUIArray, msExchPurportedSearcyUIArray
    tempmsExchPurportedSearcyUIArray = Array("Microsoft.PropertyWell_Condition0=5", _
                                             "Microsoft.PropertyWell_Property0=userPrincipalName", _
                                             "Microsoft.PropertyWell_ObjectClass0=user", _
                                             "Microsoft.PropertyWell_Items=1", _
                                             "Exchange_ObjectTypes=0", _
                                             "DsQuery_EnableFilter=0", _
                                             "DsQuery_ViewMode=4868", _
                                             "CommonQuery_Form=E23FEE83D957D011B93200A024AB2DBB", _
                                             "CommonQuery_Handler=5EE6238AC231D011891C00A024AB2DBB")
                                             
    msExchPurportedSearcyUIArray = AddToArray(tempmsExchPurportedSearcyUIArray, "Microsoft.PropertyWell_Value0=" & RootOUName)
    
    ' Set Static Properties
    newMsExchpolicyOrder = 1
    newMsExchProxyGenOptions = 0
        
    newGatewayProxy = AddToArray(DFGatewayProxy, "SMTP:@" & RootOUName)
    
    '****************************
    ' Create the New Policy Object
    

    Set NewPolicy = oRecipientPolicyCont.Create("msExchRecipientPolicy", _
                                                "CN=" & RootOUName & " - user")
    
    '****************************
    ' Values that are the same as the default policy
    NewPolicy.systemFlags = DFsystemFlags
    NewPolicy.msExchPolicyOptionList = DFmsExchPolicyOptionList
    
    ' Same Setting as in Default Policy, but with a new SMTP Setting.
    NewPolicy.gatewayproxy = newGatewayProxy
    
    '****************************
    'Standard Settings
    NewPolicy.msExchpolicyOrder = newMsExchpolicyOrder
    NewPolicy.msExchProxyGenOptions = newMsExchProxyGenOptions
    
    ' This setting is used to only apply this policy to a specific set of
    '   SMTP servers.  It will only modify their Metabase information instead
    '   of all of them if not set.
    'NewPolicy.msExchAppliesToSmtpVS            = "<SMTP Server List in Array>"
    
    '****************************
    ' Unique Settings
    NewPolicy.purportedSearch = newPurportedSearch
    NewPolicy.msExchPurportedSearchUI = msExchPurportedSearcyUIArray
    
    NewPolicy.SetInfo
        ' Need some error handling
    
    'Kill Objects
    '//Set RecipientPolicyCont = Nothing
    Set NewPolicy = Nothing
    
End Function


'********************************************************************
'*
'* Function CreateGroupRecipientPolicy(oOuObj)
'* Purpose: Create a Recipient Policy for an Organization
'* Input:       oOuObj          Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function CreateGroupRecipientPolicy(oOuObj, oRecipientPolicyCont)
'On Error Resume Next
    ' Dim Object Variables
    Dim rootDSE
    Dim NewPolicy
    
    ' Dim other Variables
    Dim newPurportedSearch, newGatewayProxy, newMsExchpolicyOrder, newMsExchProxyGenOptions
    Dim RootOUName
        
    
    '*****************************************************************
    ' Begin Creation of the new Recipient Policy
    
    ' Get Root OU Name
    RootOUName = GetRootOU(oOuObj.ADsPath)
    
    ' Create the Purported Search Filter
    newPurportedSearch = _
        "(&(&(&amp;(&(mailnickname=*) (|" & _
        "(&(objectCategory=person)(objectClass=user)(!(homeMDB=*))(!(msExchHomeServerName=*)))" & _
        "(&(objectCategory=person)(objectClass=user)(|(homeMDB=*)(msExchHomeServerName=*)))" & _
        "(&(objectCategory=person)(objectClass=contact))(objectCategory=group)" & _
        "(objectCategory=publicFolder) " & _
        ")))(objectCategory=group)(displayName=*@" & RootOUName & ")))"
    
    'Create msExchPurportedSearchUI Array
    Dim tempmsExchPurportedSearcyUIArray, msExchPurportedSearcyUIArray
    tempmsExchPurportedSearcyUIArray = Array("Microsoft.PropertyWell_Condition0=5", "Microsoft.PropertyWell_Property0=displayName", "Microsoft.PropertyWell_ObjectClass0=group", "Microsoft.PropertyWell_Items=1", "Exchange_StgChoice=0", "Exchange_ObjectTypes=31", "DsQuery_EnableFilter=0", "DsQuery_ViewMode=4868", "CommonQuery_Form=F6DA6C00B35DD2118F4000C04F9914BD", "CommonQuery_Handler=5EE6238AC231D011891C00A024AB2DBB")
    msExchPurportedSearcyUIArray = AddToArray(tempmsExchPurportedSearcyUIArray, "Microsoft.PropertyWell_Value0=" & RootOUName)
    
    ' Set Static Properties
    newMsExchpolicyOrder = 1
    newMsExchProxyGenOptions = 0
        
    newGatewayProxy = AddToArray(DFGatewayProxy, "SMTP:@" & RootOUName)
    
    '****************************
    ' Create the New Policy Object
    

    Set NewPolicy = oRecipientPolicyCont.Create("msExchRecipientPolicy", "CN=" & RootOUName & " - group")
    
    '****************************
    ' Values that are the same as the default policy
    NewPolicy.systemFlags = DFsystemFlags
    NewPolicy.msExchPolicyOptionList = DFmsExchPolicyOptionList
    
    ' Same Setting as in Default Policy, but with a new SMTP Setting.
    NewPolicy.gatewayproxy = newGatewayProxy
    
    '****************************
    'Standard Settings
    NewPolicy.msExchpolicyOrder = newMsExchpolicyOrder
    NewPolicy.msExchProxyGenOptions = newMsExchProxyGenOptions
    
    ' This setting is used to only apply this policy to a specific set of
    '   SMTP servers.  It will only modify their Metabase information instead
    '   of all of them if not set.
    'NewPolicy.msExchAppliesToSmtpVS            = "<SMTP Server List in Array>"
    
    '****************************
    ' Unique Settings
    NewPolicy.purportedSearch = newPurportedSearch
    NewPolicy.msExchPurportedSearchUI = msExchPurportedSearcyUIArray
    
    NewPolicy.SetInfo
        ' Need some error handling
    
    'Kill Objects
  
    Set NewPolicy = Nothing
    
End Function

'********************************************************************
'*
'* Function DeleteRecipientPolicy(oOuObj, sType)
'* Purpose: Delete a Recipient Policy for an Organization
'* Input:       oOuObj          Organization Unit Object (Object)
'*                sType - user or group recipient policy
'*
'* Output:  None
'*
'********************************************************************
Function DeleteRecipientPolicy(oOu, sType)
 On Error Resume Next
    ' Dim Object Variables
    Dim RecipientPolicyCont As Object
    Dim lRet As Integer
    Dim RootOUName As String
    
    ' Get Root OU Name
    RootOUName = GetRootOU(oOu.ADsPath)
    
    ' Get the Recipient Policy Container from AD (In Config Container)
    Set RecipientPolicyCont = GetRecipientPolicyContainer()
    lRet = RecipientPolicyCont.Delete("msExchRecipientPolicy", "CN=" & RootOUName & sType)
    
    Set RecipientPolicyCont = Nothing

End Function

'********************************************************************
'*
'* Function DeleteGAL(oOu)
'* Purpose: Delete a GAL for an Organization
'* Input:       oOuObj          Organization Unit Object (Object)
'*
'*
'* Output:  None
'*
'********************************************************************
Function DeleteGAL(oOu)
 On Error Resume Next
    ' Dim Object Variables
    Dim AddressListCont As Object
    Dim lRet As Integer
    Dim RootOUName As String
    
    ' Get Root OU Name
    RootOUName = GetRootOU(oOu.ADsPath)
    
    ' Get the address list Container from AD (In Config Container)
    Set AddressListCont = GetAddressListContainer()
    lRet = AddressListCont.Delete("addressBookContainer", "CN=" & RootOUName)
    
    Set AddressListCont = Nothing

End Function
'********************************************************************
'*
'* Function AddToArray(arrItem,varNewValue)
'* Purpose: Add and item to an existing Array
'* Input:       arrItem         Existing Array (Array)
'*              varNewValue     New Item to put in Existing array (String)
'*
'* Output:  Array
'*
'********************************************************************
Function AddToArray(arrItem, varNewValue)

    Dim Item, arrItemMax, newArrMax, i, counter
    ' Get the Current top limit in the Array
    arrItemMax = UBound(arrItem)
    newArrMax = arrItemMax + 1
    counter = 0
    
    ' Dim the new Array to be one size larger than the current one
    ReDim NewArray(newArrMax)
        For Each i In arrItem
            NewArray(counter) = LCase(i)
            counter = counter + 1
        Next
    'Add Final Value
    NewArray(counter) = varNewValue
    
    'Pass Array Back
    AddToArray = NewArray

End Function



'********************************************************************
'*
'* Function GetRecipientPolicyContainer()
'* Purpose: Get the Recipient Policy Container
'* Input:   None
'*
'* Output:  Object - msExchRecipientPolicyContainer
'*
'********************************************************************
Function GetRecipientPolicyContainer()
    
' ***  Begin building The Return List Array


        ' Set Counter to 0 for use int AddResultArray Function
        ResultArrayCounter = 0

        ' Begin Adding Items to Result Array that you want returned
        AddResultArray "objectClass"
        AddResultArray "objectCategory"
        AddResultArray "Name"
        AddResultArray "distinguishedName"
        AddResultArray "adsPath"
        AddResultArray "cn"

' *** Done  building The Return List Array


    'Use CheckSearchArray to Set Array Size
    ArrayCounter = 0
    CheckSearchArray "ObjectClass"  ' This is Later Used by the objectClass Attrib
    CheckSearchArray "CN=Default Policy"
    
    ' Check to See if there are any items to search for
    If ArrayCounter = 0 Then
        Exit Function
        '//List1.AddItem "No Items where entered to search for ..."

    Else
        
        'Reset Counter for use in Array
        ArrayCounter = 0
        
        AddSearchArray "objectClass", "msExchRecipientPolicyContainer"
        
        ' Do the Search and set the FindUser Object (ADO RecordSet) as the Results.
        Set oTempRecipientPolicy = SearchGCForObjects(SearchArrayItems, ResultArrayItems, "", 0)
        oTempRecipientPolicy.MoveFirst
        
        Set GetRecipientPolicyContainer = GetAdsObj(Replace(oTempRecipientPolicy.Fields("adspath"), "GC://", "LDAP://"))
        ' Kill Objects
        Set oTempRecipientPolicy = Nothing
        
    End If
    

End Function





'********************************************************************
'*
'* Function MailEnableGrp(userAdsPath, MailboxPath, UserAlias)
'* Purpose: Create a mailbox for a given user
'* Input:       userAdsPath     AdsPath of the User (String)
'*              emailAddress    Email Address for the Group (String)
'*              UserAlias       email alias for the user (String)
'*
'* Output:  None
'*
'********************************************************************
Function MailEnableGrp(groupAdsPath, emailAddress, groupAlias)
    'Dim Objects
    Dim ObjWebAdmin, objGroup
    
    Dim lRet As Long
    
    'Dim Other Variables
    Dim User
        
    ' Create the Web Admin Exchange Provisioning Object
    '//Set ObjWebAdmin = Server.CreateObject("MsWebAdmin.Exchange")
    
    
    ' Mail enable an existing group.
    '//edtrem    ObjWebAdmin.MailEnableGroup groupAdsPath, groupAlias
    lRet = MailEnableGroup(groupAdsPath, groupAlias)
    ' Get the User object for the given User
    Set objGroup = GetAdsObj(groupAdsPath)
    
    ' Set the Email Address
    objGroup.Put "mail", emailAddress
    
    ' Save Information to AD
    objGroup.SetInfo
        If Err.Number <> 0 Then
            WriteLog "MailEnableGroup", 1, "Group:" & groupAdsPath & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
        Else
            WriteLog "MailEnableGroup", 0, "Group:" & groupAdsPath & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
        End If
    
    ' Destroy Objects
    Set ObjWebAdmin = Nothing
    Set objGroup = Nothing
    
End Function




'********************************************************************
'*
'* Function GetExchangeServerList()
'* Purpose: Returns a list of all the Exchange Servers in the Forest
'* Input:   None
'*
'* Output:  ADODB Recordset
'*
'********************************************************************
Function GetExchangeServerList()
    
' ***  Begin building The Return List Array


        ' Set Counter to 0 for use int AddResultArray Function
        ResultArrayCounter = 0

        ' Begin Adding Items to Result Array that you want returned
        AddResultArray "objectClass"
        AddResultArray "objectCategory"
        AddResultArray "Name"
        AddResultArray "distinguishedName"
        AddResultArray "adsPath"
        AddResultArray "cn"

' *** Done  building The Return List Array


    'Use CheckSearchArray to Set Array Size
    ArrayCounter = 0
    CheckSearchArray "ObjectClass"  ' This is Later Used by the objectClass Attrib
    CheckSearchArray "spacer"
    
    ' Check to See if there are any items to search for
    If ArrayCounter = 0 Then
       Exit Function
       '//List1.AddItem "No Items where entered to search for ..."

    Else
        
        'Reset Counter for use in Array
        ArrayCounter = 0
        
        AddSearchArray "objectClass", "msExchExchangeServer"
        
        ' Do the Search and set the FindUser Object (ADO RecordSet) as the Results.
        Set oTempGetExchangeServerList = SearchGCForObjects(SearchArrayItems, ResultArrayItems, "", 0)
        
        ' Return the Recordset
        Set GetExchangeServerList = oTempGetExchangeServerList
        
        ' Kill Objects
        Set oTempGetExchangeServerList = Nothing
        
    End If
    

End Function

'********************************************************************
'*
'* Function PolicyExist(strPolicyName)
'* Purpose: Checks to see if a Policy exists in the Recipient Policy Container
'* Input:       strPolicyName       Name of Recipient Policy (String)
'*
'* Output:  True/False
'*
'********************************************************************
Function PolicyExist(strPolicyName)
On Error Resume Next
    ' Dim Objects
    Dim RecipientPolicyCont, tempPolicy
    
    ' Get the Recipient Policy Container from AD (In Config Container)
    Set RecipientPolicyCont = GetRecipientPolicyContainer()
    
    ' Get the Default Policy from the Recipient Policy Container
    Set tempPolicy = RecipientPolicyCont.GetObject("msExchRecipientPolicy", strPolicyName)
        If Err.Number <> 0 Then
            PolicyExist = False
        Else
            PolicyExist = True
        End If
    
    ' Kill Objects
    Set tempPolicy = Nothing
    Set RecipientPolicyCont = Nothing
End Function


'********************************************************************
'*
'* Function GetPolicyByName(strPolicyName)
'* Purpose: Get and Return the Recipient Policy
'* Input:       strPolicyName       Name of Recipient Policy (String)
'*
'* Output:  Object - msExchRecipientPolicy
'*
'********************************************************************
Function GetPolicyByName(strPolicyName)
'On Error Resume Next
    ' Dim Objects
    Dim RecipientPolicyCont, tempPolicy
    
    '///List1.additem "strPolicyName: " & strPolicyName
    
    ' Get the Recipient Policy Container from AD (In Config Container)
    Set RecipientPolicyCont = GetRecipientPolicyContainer()
    '//List1.AddItem "RecipientPolicyCont: " & RecipientPolicyCont.Name
    'Response.End
    
    ' Get the Default Policy from the Recipient Policy Container
    Set tempPolicy = RecipientPolicyCont.GetObject("msExchRecipientPolicy", strPolicyName)
    
    
    ' Return the Recipient Policy Object
    Set GetPolicyByName = tempPolicy
    
    ' Kill Objects
    Set tempPolicy = Nothing
    Set RecipientPolicyCont = Nothing
    
End Function

'********************************************************************
'*
'* Function PickoffLineABServer()
'* Purpose: Return a Server for use as an Offline store
'* Input:   None
'*
'* Output:  String
'*
'********************************************************************
Function PickoffLineABServer()
    'Dim Objects
    Dim tempExchServers
    
    'Dim Other Variables
    Dim numOfExchSrv, rndNubmer, tempChosenServer
    
    If Not PREFERED_OAB_EXCH_SERVER = "" Then
        PickoffLineABServer = PREFERED_OAB_EXCH_SERVER
        Exit Function
    Else
        'Get a recordset of all of the exchange Servers from within th entire forest
        'Set tempExchServers = server.CreateObject("adodb.recordset")
        Set tempExchServers = GetExchangeServerList()
        
        'Get the total number of Exchange Servers
        numOfExchSrv = tempExchServers.RecordCount
        
        ' Pick a random number that will represent what server to pick from the
        '   Exchange recordset
        Randomize
        rndNubmer = Int((numOfExchSrv * Rnd) + 1)
        
        ' Move to the Chosen Server
        tempExchServers.Move (rndNubmer - 1)
        
        ' Get the AdsPath of the Chosen Exchange Server
        tempChosenServer = Replace(LCase(tempExchServers("adspath")), "gc://", "")
        
        PickoffLineABServer = tempChosenServer
        
        ' Kill Object(s)
        'Set tempExchServers = Nothing
    End If
End Function



'********************************************************************
'*
'* Function CreateGAL(oOu)
'* Purpose: Creates a GAL for an ASP Exchange Customer.
'* Input:       oOu          Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function CreateGAL(oOu)
'On Error Resume Next
    ' Dim Object Variables
    Dim NewAddressList As Object
    Dim AddressListCont As Object
    Dim NewGAL As Object
    Dim SecurityDescriptor, Dacl, parentSD As Object, parentDACL As Object, copyDACL As Object
    
    ' Dim other Variables
    Dim newPurportedSearch As String, newGatewayProxy, newMsExchpolicyOrder, newMsExchProxyGenOptions
    Dim RootOUName As String, iCurrentControl
    
 
    '*****************************************************************
    ' Begin Creation of the new GAL
  
    ' Get Root OU Name
    RootOUName = GetRootOU(oOu.ADsPath)
    
    ' Create the Purported Search Filter
    'newPurportedSearch = _
    '   "(&(&(&(mailnickname=*)"&_
    '   "(|&(objectCategory=person"&_
    '   "(objectClass=user)(username=*@" & RootOUName & "))"&_
    '   "(&(objectCategory=group)(displayName=*@" & RootOUName & "))))))"
    
    newPurportedSearch = _
        "(&(&(&(|(&(objectCategory=person)(objectSid=*)" & _
        "(!samAccountType:1.2.840.113556.1.4.804:=3))" & _
        "(&(objectCategory=person)(!objectSid=*))" & _
        "(&(objectCategory=group)" & _
        "(groupType:1.2.840.113556.1.4.804:=14))))" & _
        "(objectCategory=user)(userPrincipalName=*@" & RootOUName & ")))"
    
            
    'Create msExchPurportedSearchUI Array
    Dim tempmsExchPurportedSearcyUIArray, msExchPurportedSearcyUIArray
    
    tempmsExchPurportedSearcyUIArray = Array("Microsoft.PropertyWell_Condition0=5", "Microsoft.PropertyWell_Property0=userPrincipalName", "Microsoft.PropertyWell_ObjectClass0=user", "Microsoft.PropertyWell_Items=1", "Exchange_ObjectTypes=0", "DsQuery_EnableFilter=0", "DsQuery_ViewMode=4868", "CommonQuery_Form=E23FEE83D957D011B93200A024AB2DBB", "CommonQuery_Handler=5EE6238AC231D011891C00A024AB2DBB")
    msExchPurportedSearcyUIArray = AddToArray(tempmsExchPurportedSearcyUIArray, "Microsoft.PropertyWell_Value0=@" & RootOUName)
    
    
    '****************************
    ' Create the New Policy Object
    
    ' Get the AddressList  Policy Container from AD (In Config Container)
    Set AddressListCont = GetAddressListContainer()
    ' Create the New Address List
    Set NewAddressList = AddressListCont.Create("addressBookContainer", "CN=" & RootOUName)
        If Err.Number <> 0 Then
            WriteLog "CreateGAL", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: CreateGAL()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
        End If
    
    '
    '****************************
    
    '****************************
    ' Unique Settings
    
    NewAddressList.DisplayName = RootOUName
    NewAddressList.purportedSearch = newPurportedSearch
    NewAddressList.msExchPurportedSearchUI = msExchPurportedSearcyUIArray

    '
    '****************************
    
    '****************************
    '   Save New GAL
    NewAddressList.SetInfo
    If Err.Number <> 0 Then
       WriteLog "CreateGAL", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: CreateGAL()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
    End If
        
    '****************************
    ' Security Settings
    
    ' Set Proper Ace Entries
    Set SecurityDescriptor = NewAddressList.Get("ntSecurityDescriptor")
    'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (oOu)"
    Set Dacl = SecurityDescriptor.DiscretionaryAcl
    'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (oOu)"
    
    ' Get the Security Control
    iCurrentControl = SecurityDescriptor.Control
    
    ' Protect this Objects Security Descriptor from Inheritance
    SecurityDescriptor.Control = iCurrentControl Or SE_DACL_PROTECTED
    
    ' Get the Parent Containers DACL
    Set parentSD = AddressListCont.Get("ntSecurityDescriptor")
    Set parentDACL = parentSD.DiscretionaryAcl
    
    ' Copy DACL from Parent.
    Set copyDACL = parentDACL.CopyAccessList()

    ' Remove the ability for any user in the Directory to access this
    '   OU or its object
    DeleteAce copyDACL, "NT AUTHORITY\Authenticated Users"
    
    ' Allow Users from within this OU to have read rights to this GAL
    ' CHEAT Sheet: AddAce(TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
    
    AddAce copyDACL, constALL_USERS_GROUP & RootOUName, 131220, 0, 2, 0, 0, 0
    'DetailError "Unable to ADD an ACE (ResetASPSecurity)"
    
    AddAce copyDACL, constALL_USERS_GROUP & RootOUName, 256, 5, 2, 1, "{A1990816-4298-11D1-ADE2-00C04FD8D5CD}", 0
    'DetailError "Unable to ADD an ACE (ResetASPSecurity)"
    
    ' Reorder the DACL to a proper State.
    Set copyDACL = ReorderACL(copyDACL)
    
    '*** Add New Dacl to the Security Descriptor
    SecurityDescriptor.DiscretionaryAcl = copyDACL
    NewAddressList.Put "ntSecurityDescriptor", SecurityDescriptor
    '
    '****************************
    
    '****************************
    '   Save New GAL
    NewAddressList.SetInfo
    If Err.Number <> 0 Then
       WriteLog "CreateGAL", 1, "Org: " & GetRootOU(oOu.ADsPath) & Chr(10) & "Failed in Function: CreateGAL()" & Chr(10) & "Err.num: " & Err.Number & Chr(10) & "Err.desc: " & Err.Description
    End If

    'Kill Objects
    Set NewAddressList = Nothing
    Set NewGAL = Nothing
    Set parentSD = Nothing
    Set parentDACL = Nothing
    Set copyDACL = Nothing
    Set AddressListCont = Nothing
    
End Function


'********************************************************************
'*
'* Function CreateGroupGAL(oOuObj)
'* Purpose: Creates a GAL for an ASP Exchange Customers Group.
'* Input:       oOuObj          Organization Unit Object (Object)
'*
'* Output:  None
'*
'********************************************************************
Function CreateGroupGAL(oOuObj)
'On Error Resume Next
    ' Dim Object Variables
    Dim rootDSE, AddressListCont, NewAddressList
    Dim NewGAL
    Dim SecurityDescriptor, Dacl, parentSD, parentDACL, copyDACL
    
    ' Dim other Variables
    Dim newPurportedSearch, newGatewayProxy, newMsExchpolicyOrder, newMsExchProxyGenOptions
    Dim RootOUName, iCurrentControl
    
    
    '*****************************************************************
    ' Begin Creation of the new GAL
    
    ' Get Root OU Name
    RootOUName = GetRootOU(oOuObj.ADsPath)
    
    ' Create the Purported Search Filter
    'newPurportedSearch = _
    '   "(&(&(&(mailnickname=*)"&_
    '   "(|&(objectCategory=person"&_
    '   "(objectClass=user)(username=*@" & RootOUName & "))"&_
    '   "(&(objectCategory=group)(displayName=*@" & RootOUName & "))))))"
    newPurportedSearch = _
        "(&(&(&(|(&(objectCategory=person)(objectSid=*)" & _
        "(!samAccountType:1.2.840.113556.1.4.804:=3))" & _
        "(&(objectCategory=person)(!objectSid=*))" & _
        "(&(objectCategory=group)" & _
        "(groupType:1.2.840.113556.1.4.804:=14))))" & _
        "(objectCategory=user)(userPrincipalName=*@" & RootOUName & ")))"
    
            
    'Create msExchPurportedSearchUI Array
    Dim tempmsExchPurportedSearcyUIArray, msExchPurportedSearcyUIArray
    
    tempmsExchPurportedSearcyUIArray = Array("Microsoft.PropertyWell_Condition0=5", "Microsoft.PropertyWell_Property0=userPrincipalName", "Microsoft.PropertyWell_ObjectClass0=user", "Microsoft.PropertyWell_Items=1", "Exchange_ObjectTypes=0", "DsQuery_EnableFilter=0", "DsQuery_ViewMode=4868", "CommonQuery_Form=E23FEE83D957D011B93200A024AB2DBB", "CommonQuery_Handler=5EE6238AC231D011891C00A024AB2DBB")
    msExchPurportedSearcyUIArray = AddToArray(tempmsExchPurportedSearcyUIArray, "Microsoft.PropertyWell_Value0=@" & RootOUName)
    
    
    '****************************
    ' Create the New Policy Object
    
    ' Get the Recipient Policy Container from AD (In Config Container)
    Set AddressListCont = GetAddressListContainer()
    ' Create the New Address List
    Set NewAddressList = AddressListCont.Create("addressBookContainer", "CN=" & RootOUName)
        
     '//need error handling
     '//   If Err.Number <> 0 Then
     '//       List1.AddItem "Error Creating Object" & RootOUName
     '//   Else
     '//       List1.AddItem "Created new AddressBook OK " & RootOUName
     '//   End If
    
    '
    '****************************
    
    '****************************
    ' Unique Settings
    
    NewAddressList.DisplayName = RootOUName
    NewAddressList.purportedSearch = newPurportedSearch
    NewAddressList.msExchPurportedSearchUI = msExchPurportedSearcyUIArray

    '
    '****************************
    
    '****************************
    '   Save New GAL
    NewAddressList.SetInfo
    '//need error handling
    '//If Err.Number <> 0 Then
    '//        List1.AddItem "Error Setting info on Object" & RootOUName
    '//        List1.AddItem "Err Desc: " & Err.Description
    '//        List1.AddItem "Err numb: " & Err.Number
    '//        List1.AddItem "Err sour: " & Err.Source
    '//
    '//    Else
    '//        List1.AddItem "GAL Saved OK.  Now Setting Security " & RootOUName
    '//    End If
        
    '****************************
    ' Security Settings
    
    ' Set Proper Ace Entries
    Set SecurityDescriptor = NewAddressList.Get("ntSecurityDescriptor")
    'DetailError "Unable to Access the SecurityDescriptor or Access is Denied (oOuObj)"
    Set Dacl = SecurityDescriptor.DiscretionaryAcl
    'DetailError "Unable to Access the DiscretionaryAcl or Access is Denied (oOuObj)"
    
    ' Get the Security Control
    iCurrentControl = SecurityDescriptor.Control
    
    ' Protect this Objects Security Descriptor from Inheritance
    SecurityDescriptor.Control = iCurrentControl Or SE_DACL_PROTECTED
    
    ' Get the Parent Containers DACL
    Set parentSD = AddressListCont.Get("ntSecurityDescriptor")
    Set parentDACL = parentSD.DiscretionaryAcl
    
    ' Copy DACL from Parent.
    Set copyDACL = parentDACL.CopyAccessList()

    ' Remove the ability for any user in the Directory to access this
    '   OU or its object
    DeleteAce copyDACL, "NT AUTHORITY\Authenticated Users"
    
    ' Allow Users from within this OU to have read rights to this GAL
    ' CHEAT Sheet: AddAce(TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
    AddAce copyDACL, "AllUsers@" & RootOUName, 131220, 0, 2, 0, 0, 0
    'DetailError "Unable to ADD an ACE (ResetASPSecurity)"
    
    AddAce copyDACL, "AllUsers@" & RootOUName, 256, 5, 2, 1, "{A1990816-4298-11D1-ADE2-00C04FD8D5CD}", 0
    'DetailError "Unable to ADD an ACE (ResetASPSecurity)"
    
    ' Reorder the DACL to a proper State.
    Set copyDACL = ReorderACL(copyDACL)
    
    '*** Add New Dacl to the Security Descriptor
    SecurityDescriptor.DiscretionaryAcl = copyDACL
    NewAddressList.Put "ntSecurityDescriptor", SecurityDescriptor
    '
    '****************************
    
    '****************************
    '   Save New GAL
    NewAddressList.SetInfo
    
    '//need error handling
    '//If Err.Number <> 0 Then
    '//        List1.AddItem "Error Setting info on Object" & RootOUName
    '//        List1.AddItem "Err Desc: " & Err.Description
    '//        List1.AddItem "Err numb: " & Err.Number
    '//        List1.AddItem "Err sour: " & Err.Source
    '//
    '//    Else
    '//        List1.AddItem "GAL Securiy Set.  GAL Creation is Complete " & RootOUName
    '//    End If
        ' Need some error handling
    
    'Kill Objects
    Set NewAddressList = Nothing
    Set NewGAL = Nothing
    Set parentSD = Nothing
    Set parentDACL = Nothing
    Set copyDACL = Nothing
    
End Function

'********************************************************************
'*
'* Function GetAddressListContainer()
'* Purpose: Return the Global Address List Container.
'* Input:   None
'*
'* Output:  Object - addressBookContainer
'*
'********************************************************************
Function GetAddressListContainer()
    Dim tempAddressListContainer
    
' ***  Begin building The Return List Array


        ' Set Counter to 0 for use int AddResultArray Function
        ResultArrayCounter = 0

        ' Begin Adding Items to Result Array that you want returned
        AddResultArray "objectClass"
        AddResultArray "objectCategory"
        AddResultArray "Name"
        AddResultArray "distinguishedName"
        AddResultArray "adsPath"
        AddResultArray "cn"

' *** Done  building The Return List Array


    'Use CheckSearchArray to Set Array Size
    ArrayCounter = 0
    CheckSearchArray "ObjectClass"  ' This is Later Used by the objectClass Attrib
    CheckSearchArray "CN=All Global Address Lists"
    
    ' Check to See if there are any items to search for
    If ArrayCounter = 0 Then
        Exit Function
        '//List1.AddItem "No Items where entered to search for ..."
        
    Else
        
        'Reset Counter for use in Array
        ArrayCounter = 0
        
        AddSearchArray "objectClass", "addressBookContainer"
        
        ' Do the Search and set the FindUser Object (ADO RecordSet) as the Results.
        Set tempAddressListContainer = SearchGCForObjects(SearchArrayItems, ResultArrayItems, "", 0)
        
        tempAddressListContainer.MoveFirst
        
        Set GetAddressListContainer = GetAdsObj(Replace(tempAddressListContainer.Fields("adspath"), "GC://", "LDAP://"))
        ' Kill Objects
        Set tempAddressListContainer = Nothing
        
    End If
    

End Function

'**********************
' edtrem - evaluate need for the following routines
'//*****************


'********************************************************************
'*
'* Function GetRootOU(sAdsPath)
'* Purpose: Get/Return the Root OU of a Given Object
'* Input:       sAdsPath            Ads Path of Object (String)
'*
'* Example : Input      = Ldap://OU=Child2,OU=Child1,OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output     = TestOU
'*
'* Output:      String - Root Organizational Unit
'*
'********************************************************************
Function GetRootOU(sAdsPath)
    Dim topDomainLoc, OtherSideOfOULoc, TotalLength, HostingOULoc, HostingVarLen
    TotalLength = Len(sAdsPath)
    topDomainLoc = InStr(1, UCase(sAdsPath), "DC=")
        ' Check to see if ASP Services is Enabled
        If ASP_SERVICES_ENABLED Then
            HostingVarLen = Len("OU=" & UCase(HOSTING_OU))
            HostingOULoc = InStr(1, UCase(sAdsPath), "OU=" & UCase(HOSTING_OU))
            If HostingOULoc = 0 Then
                HostingOULoc = InStr(1, UCase(sAdsPath), "CN=")
                    If HostingOULoc = 0 Then
                        GetRootOU = sAdsPath
                    Else
                        OtherSideOfOULoc = InStrRev(UCase(sAdsPath), "DC=", HostingOULoc)
                        GetRootOU = Mid(sAdsPath, topDomainLoc)
                    End If
            Else
                OtherSideOfOULoc = InStrRev(UCase(sAdsPath), "OU=", HostingOULoc)
                GetRootOU = Mid(sAdsPath, OtherSideOfOULoc + 3, topDomainLoc - OtherSideOfOULoc - HostingVarLen - 5)
            End If
        Else
            OtherSideOfOULoc = InStrRev(UCase(sAdsPath), "OU=")
            GetRootOU = Mid(sAdsPath, OtherSideOfOULoc + 3, topDomainLoc - OtherSideOfOULoc - 4)
        End If
End Function
'********************************************************************
'*
'* Function WriteLog(logAction, logResult, logOther)
'* Purpose: Write to a Log File or Database
'* Input:       logAction           Action that has/will be taken. (String)
'*              logResult           Result of Action. (Integer- See Above)
'*              logOther            Any other information that should be noted. (String)
'*
'* Output:  None
'*
'********************************************************************
Function WriteLog(logAction, logResult, logOther)
    '//need logging function
    '//List1.AddItem "action: " & logAction & "result: " & logResult & " " & logOther
End Function

'********************************************************************
'*
'* Function CleanOutProtocol(sAdsPath)
'* Purpose: Take the Protocal out of the Ads Path
'* Input:       sAdsPath            ADSPath of an object. (String)
'*
'* Output:      True/False
'*
'********************************************************************
Function CleanOutProtocol(sAdsPath)
    Dim tempDn
    tempDn = Mid(sAdsPath, 8)
    CleanOutProtocol = tempDn
End Function

'********************************************************************
'*
'* Function ParseUsername(g_UPN)
'* Purpose: Get/Return the User name from the UPN
'* Input:       g_UPN       User UPN (String)
'*
'* Output:      String - Username (without the UPN)
'*
'********************************************************************
Function ParseUsername(g_UPN)
    Dim AtSignLoc
    AtSignLoc = InStr(1, g_UPN, "@")
    If AtSignLoc <> 0 Then
        ParseUsername = Mid(g_UPN, 1, AtSignLoc - 1)
    Else
        ' Assume the UPN passed does not have an At Sign.
        ParseUsername = g_UPN
    End If
End Function

'********************************************************************
'*
'* Function AddResultArray(varItem)
'* Purpose: Add Item to Results Array
'*
'* Input:       varItem     Items Value (String)
'*
'* Output:      None
'*
'********************************************************************
Function AddResultArray(varItem)
    If varItem <> "" Then
        ResultArrayItems(ResultArrayCounter) = varItem
        ResultArrayCounter = ResultArrayCounter + 1
    End If
End Function

'********************************************************************
'*
'* Function CheckSearchArray(varValue)
'* Purpose: Check to see if an Item has a value.  And if it does
'*              Make the Array for the Results grow by 1
'*
'* Input:       varValue        Item to Check for (String)
'*
'* Output:      None
'*
'********************************************************************
Function CheckSearchArray(varValue)
    If varValue <> "" Then
        ReDim SearchArrayItems(ArrayCounter)
        ArrayCounter = ArrayCounter + 1
    End If
End Function

'********************************************************************
'*
'* Function AddSearchArray(varItem, varValue)
'* Purpose: Use this Function to add Its to the SearchArrayItems Pulic Array
'* Input:       varItem     Name of Attribute (String)
'*              varValue    Value to Search For (String)
'*
'* Output:      None
'*
'********************************************************************
Function AddSearchArray(varItem, varValue)
    If varValue <> "" Then
        SearchArrayItems(ArrayCounter) = varItem & "=" & varValue
        ArrayCounter = ArrayCounter + 1
    End If
End Function

'********************************************************************
'*
'* Function SearchGCForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
'* Purpose: Does same as SearchGCForObjects, but searchs the GC instead
'*              of LDAP and does not restrict for ASPHosting or not.
'*
'* Input:       SearchArrayItems        Items & Values to Search For (Array)
'*              ReturnItemsArray        Items to Return (Array)
'*              varSearchScope          Scope; SubTree (0) / One-Level (1)
'*              intSearchDepth          (Not Yet Implemented)
'* Output:  None
'*
'********************************************************************
Function SearchGCForObjects(SearchArrayItems, ReturnItemsArray, varSearchScope, intSearchDepth)
On Error Resume Next
    Dim X, MyUser
    Dim con, rs, adsQuery
    Dim SearchFor, SearchItem, SearchDepth
    Dim ReturnItems, CompleteReturnItems
    Dim oRootDse As IADs

    Set con = CreateObject("ADODB.Connection")
    DetailError "Could not Create ADODB.Connection Object (SearchForObjects)"
    
    Set rs = CreateObject("ADODB.Recordset")
    DetailError "Could not Create ADODB.Recordset Object (SearchForObjects)"
        
    con.Provider = "ADsDSOObject"
    con.Open "Active Directory Provider"
    
    For Each SearchItem In SearchArrayItems
        If Trim(SearchItem) <> "" Then
            SearchFor = SearchFor & "(" & SearchItem & ")"
        End If
    Next
    
    ' Build the Return Result Attributes for the Query
    For Each ReturnItems In ReturnItemsArray
        If Trim(ReturnItems) <> "" Then
            CompleteReturnItems = CompleteReturnItems & ReturnItems & ","
        End If
    Next
    ' Clean out the Last Comma from CompleteReturnItems
    CompleteReturnItems = Mid(CompleteReturnItems, 1, Len(CompleteReturnItems) - 1)
    
    ' Set Search Depth
    Select Case intSearchDepth
        Case 0
            SearchDepth = "Subtree"
        Case 1
            SearchDepth = "One-Level"
    End Select
    
   
    
    ' Bind to the rootDSE
    Set oRootDse = GetObject("LDAP://RootDSE")
        
    ' Build the Entire Search String
    adsQuery = "<GC://" & oRootDse.Get("defaultNamingContext") & ">;(&" & SearchFor & ");" & CompleteReturnItems & ";" & SearchDepth
    
    ' Execute the Query
    Set rs = con.Execute(adsQuery)
        DetailError "_Error: Could not execute ADO Query with ADSI Provider. (SearchForObjects)"
    
    ' Return the Search Results
    Set SearchGCForObjects = rs
    
    ' Kill Objects
    Set con = Nothing
    Set oRootDse = Nothing
    Set rs = Nothing
End Function

'********************************************************************
'*
'* Function GetAdsObj(g_AdsPath)
'* Purpose: Get an ADS Object (User, Group, OU, etc.) via an Ads Path
'* Input:       g_AdsPath           Object's AdsPath (String)
'*
'* Output:  None
'*
'********************************************************************
Function GetAdsObj(g_AdsPath)
On Error Resume Next
    ' Get the Object Via Ads Path
    Set GetAdsObj = GetObject(g_AdsPath)
        DetailError "You Do Not have access to view this Object or the object does not exist. (GetAdsObj)"
End Function

'//******************************
'// from the mailenableclass
'// edtrem
'//

Function MailboxEnableUser(user_AdsPath, sMailStore, sUserEmail)
    
    Dim oObjUser As IADsUser
    Dim objPerson As New CDO.Person
    Dim objMailStore As CDOEXM.IMailboxStore
   
    ' Get the user object via ADSI
    Set oObjUser = GetObject(user_AdsPath)
    
    ' Clear all email information for the user.
    oObjUser.PutEx ADS_PROPERTY_CLEAR, "mail", vbNullString
    oObjUser.PutEx ADS_PROPERTY_CLEAR, "ProxyAddresses", vbNullString
    
    ' The MailNickName must be unique per SMTP domain.
    '//oObjUser.Put "mailNickName", "JohnD1"
    oObjUser.Put "mailNickName", sUserEmail
    
    ' Save Information
    oObjUser.SetInfo
    
    ' Open Path User Object Via CDO
    objPerson.DataSource.Open user_AdsPath
    Set objMailStore = objPerson
    
    ' Create the users Mailbox
    objMailStore.CreateMailbox sMailStore
    
    ' Save the Information.
    objPerson.DataSource.Save
    
    '//Set objUser = GetAdsObj(userAdsPath)
    
    ' Set the Users msExchQueryBaseDN to the Root OU of their Organization.  This is needed
    '   for Outlook Web Access (OWA).  When a user is using OWA and looks in their Address
    '   book, OWA does a search into the directory with it's higher level of credentials.
    '   This enables users to see people in other orgs that normally they would not see based
    '   on the original users credentials and the associated security settings in the Active
    '   Directory.  So to stop that from happening, OWA looks at the users attribute
    '   msExchQueryBaseDN attribute to filter only the addresses within that OU.
    oObjUser.msExchQueryBaseDN = Replace(LCase(GetRootOUAdsPath(user_AdsPath)), "ldap://", "")
    oObjUser.SetInfo
    'Destroy Objects
    Set objPerson = Nothing
    Set objMailStore = Nothing
    Set oObjUser = Nothing
    
End Function

Function DeleteMailbox(oOu, sUsrName)
    
    Dim oObjUser As IADsUser

    Dim oMailStore As CDOEXM.IMailboxStore

    Dim oContents As Object
    
    
    For Each oContents In oOu
        If oContents.Class = "user" Then
           Set oObjUser = GetObject(oContents.ADsPath)
           Set oMailStore = oObjUser
           If oMailStore.HomeMDB <> "" Then '// null value indicates that user not assigned to storage group
              oMailStore.DeleteMailbox
              oObjUser.SetInfo
           End If
        End If
    Next


    Set oMailStore = Nothing
    Set oContents = Nothing
    Set oObjUser = Nothing
    
End Function
'********************************************************************
'*
'* Function GetRootOUAdsPath(sAdsPath)
'* Purpose: Get/Return the Ads Path of Root OU for a Given Object
'* Input:       sAdsPath            Ads Path of Object (String)
'*
'* Example : Input      = Ldap://OU=Child2,OU=Child1,OU=TestOU,DC=MyASPCompany,DC=Com
'* Example : Output     = Ldap://OU=TestOU,DC=MyASPCompany,DC=Com
'*
'* Output:      String - Root Organizational Unit Ads Path
'*
'********************************************************************
Function GetRootOUAdsPath(sAdsPath)
    Dim topDomainLoc, OtherSideOfOULoc, TotalLength, HostingOULoc
    TotalLength = Len(sAdsPath)
    topDomainLoc = InStr(1, UCase(sAdsPath), "DC=")
        ' Check to see if ASP Services is Enabled
        If ASP_SERVICES_ENABLED Then
            ' Look for the Hosting OU from the left of the AdsPath.
            HostingOULoc = InStr(1, UCase(sAdsPath), "OU=" & UCase(HOSTING_OU))
            If HostingOULoc <> 0 Then
                OtherSideOfOULoc = InStrRev(UCase(sAdsPath), "OU=", HostingOULoc)
                    ' If this is the last container than.
                    If OtherSideOfOULoc = 0 Then
                        GetRootOUAdsPath = sAdsPath
                    Else
                        GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath, OtherSideOfOULoc)
                    End If
            Else
                ' If there is no Hosting OU Present, Go For the Last OU.
                OtherSideOfOULoc = InStrRev(UCase(sAdsPath), "OU=")
                    ' If there is no OU in the AdsPath, the try CN=Users
                    If OtherSideOfOULoc = 0 Then
                        OtherSideOfOULoc = InStrRev(LCase(sAdsPath), "cn=users")
                        ' If this users in not in a container, return the full ADSPath
                        GetRootOUAdsPath = sAdsPath
                    Else
                        GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath, OtherSideOfOULoc)
                    End If
            End If
        Else
            'OtherSideOfOULoc = InstrRev(uCase(sAdsPath),"OU=")
            'GetRootOUAdsPath = "LDAP://" & Mid(sAdsPath,OtherSideOfOULoc)
            GetRootOUAdsPath = sAdsPath
        End If
End Function

Function MailEnableGroup(groupAdsPath, strGroupAlias)
    Dim objGroup As IADsGroup
    Dim objMailRecipient As CDOEXM.IMailRecipient
        
    ' Get the user object via ADSI
    Set objGroup = GetObject(groupAdsPath)
    ' Clear all email information for the user.
    objGroup.PutEx ADS_PROPERTY_CLEAR, "mail", vbNullString
    objGroup.PutEx ADS_PROPERTY_CLEAR, "ProxyAddresses", vbNullString
    
    ' The MailNickName must be unique per SMTP domain.
    objGroup.Put "mailNickName", strGroupAlias
    
    ' Save Information
    objGroup.SetInfo
    
    ' Pass Group Object to Mail Recipent Object
    Set objMailRecipient = objGroup
    
    ' Mail Enable the group.  Pass in a blank string.  A blank string is used for groups.
    '       If this were for a user or folder, the variable you pass in would be the
    '       forwarding address.  For a group, all members will get the email.
    objMailRecipient.MailEnable ""
    
    'Destroy Objects
    Set objGroup = Nothing
    Set objMailRecipient = Nothing

End Function

Function UpdatePrimeMailbox(userAdsPath, NewPrimaryAddress)
    Dim objUser As IADsUser
    
    ' Dim Strings
    Dim currentProxyAddresses
    Dim NewProxyAddresses()
    Dim items
    Dim counter As Integer
    Dim tempNewAddressValue
    
    ' Get the user object via ADSI
    Set objUser = GetObject(userAdsPath)
    ' Get the Current ProxyAddresses Array
    currentProxyAddresses = objUser.ProxyAddresses
    'For i = LBound(objUser.ProxyAddresses) To UBound(objUser.ProxyAddresses)
    '  Debug.Print objUser.ProxyAddresses(i)
    'Next
    
    Debug.Print "**** Curent Proxy Addresses"
    For Each items In currentProxyAddresses
        Debug.Print items
        counter = counter + 1
    Next
    ReDim NewProxyAddresses(counter - 1)
    
    ' Reset Counter
    counter = 0
    
    ' Go through the Current Proxy Address list and find the address that matches.
    '   Once there is a match made, make the SMTP: address up
    
    Debug.Print "**** Building New Proxy Addresses"
    For Each items In currentProxyAddresses
            If LCase(items) = LCase(NewPrimaryAddress) Then
                tempNewAddressValue = Replace(LCase(items), "smtp:", "SMTP:")
                NewProxyAddresses(counter) = tempNewAddressValue
                Debug.Print "Adding to NewProxyAddresses(" & counter & ") [Default]=" & tempNewAddressValue
            Else
                NewProxyAddresses(counter) = LCase(items)
                Debug.Print "Adding to NewProxyAddresses(" & counter & ")=" & LCase(items)
            
            End If
        counter = counter + 1
    Next
    
    'Set New Proxy Address in the Directory
    objUser.PutEx ADS_PROPERTY_CLEAR, "ProxyAddresses", vbNullString
    objUser.PutEx ADS_PROPERTY_UPDATE, "ProxyAddresses", NewProxyAddresses
    
    ' Save Information
    objUser.SetInfo
    
    ' Destroy user object
    Set objUser = Nothing
    
End Function

'********************************************************************
'*
'* Function DeleteAce(dacl, TrusteeName)
'* Purpose: Delete an Access Control Entry (ACE) from an Access Control List.
'* Input:       dacl            Access Control List (Object)
'*              TrusteeName     Name of the Trustee you want to delete
'*
'* Output:  None
'*
'********************************************************************
Function DeleteAce(Dacl, TrusteeName)
On Error Resume Next
' Bubble Any Error to the Calling Function.
    Dim oACE
    
    ' Create a temp ACE Object
    Set oACE = CreateObject("AccessControlEntry")
        ' Recurse through the ACL
        For Each oACE In Dacl
            'Find the Trustee you are looking to delete.
            If (Trim(LCase(oACE.Trustee)) = Trim(LCase(TrusteeName))) Then
                ' Delete the ACE from the ACL
                Dacl.RemoveAce (oACE)
            End If
        Next
    
    ' Kill Objects
    Set oACE = Nothing
End Function

'********************************************************************
'*
'* Function AddAce(dacl, TrusteeName, gAccessMask, gAceType,_
'*               gAceFlags, gFlags, gObjectType, gInheritedObjectType)
'*
'* Purpose: Adds and ACE to an existing ACL
'* Input:       dacl                        Access Control List (Object)
'*              TrusteeName                 Name of Trustee to add (String)
'*              gAccessMask                 AccessMask (String)
'*              gAceType                    AceType ()
'*              gAceFlags                   AceFlags ()
'*              gFlags                      Flags ()
'*              gObjectType                 ObjectType ()
'*              gInheritedObjectType        InheritedObjectType ()
'*
'* Output:  None
'*
'********************************************************************
Function AddAce(Dacl, TrusteeName, gAccessMask, gAceType, gAceFlags, gFlags, gObjectType, gInheritedObjectType)
' Bubble Error to Calling Function
On Error Resume Next
    Dim Ace1
    ' Add New Ace for Apply Policy
    Set Ace1 = CreateObject("AccessControlEntry")
    Ace1.AccessMask = gAccessMask
    Ace1.AceType = gAceType
    Ace1.AceFlags = gAceFlags
    Ace1.Flags = gFlags
    Ace1.Trustee = TrusteeName

        'Check to See if ObjectType needs to be set
        If CStr(gObjectType) <> "0" Then
            Ace1.ObjectType = gObjectType
        End If

        'Check to See if InheritedObjectType needs to be set
        If CStr(gInheritedObjectType) <> "0" Then
            Ace1.InheritedObjectType = gInheritedObjectType
        End If
    Dacl.AddAce Ace1
    
    ' Kill Objects
    Set Ace1 = Nothing
End Function

'********************************************************************
'*
'* Function ReorderACL(objDACL)
'*
'* Purpose: Reorders a DACL properly
'* Input:       objDACL                     Access Control List (Object)
'*
'* Output:  Object - Reordered DACL
'*
'********************************************************************
Function ReorderACL(objDACL)
    ' Dim Objects
    Dim ImpDenyDacl, ImpDenyObjectDacl, InheritedDacl, ImpAllowDacl, ImpAllowObjectDacl
    Dim objSD, newDACL
    
    ' Dim Other Variables
    Dim ace
    
    ' Set Constants
    Const ADS_ACEFLAG_INHERITED_ACE = &H10
    Const ADS_ACETYPE_ACCESS_ALLOWED = &H0
    Const ADS_ACETYPE_ACCESS_DENIED = &H1
    Const ADS_ACETYPE_ACCESS_ALLOWED_OBJECT = &H5
    Const ADS_ACETYPE_ACCESS_DENIED_OBJECT = &H6
    
    ' Create the New DACL
    Set objSD = CreateObject("SecurityDescriptor")
    
    ' Create the ACL Objects
    Set newDACL = CreateObject("AccessControlList")
    Set ImpDenyDacl = CreateObject("AccessControlList")
    Set ImpDenyObjectDacl = CreateObject("AccessControlList")
    Set InheritedDacl = CreateObject("AccessControlList")
    Set ImpAllowDacl = CreateObject("AccessControlList")
    Set ImpAllowObjectDacl = CreateObject("AccessControlList")
    
    ' Loop through the Original Dacl.
    For Each ace In objDACL
        If ((ace.AceFlags And ADS_ACEFLAG_INHERITED_ACE) = ADS_ACEFLAG_INHERITED_ACE) Then
            ' Don't really care about the order of inherited aces.  Since we are
            ' adding them to the top of a new list, when they are added back
            ' to the Dacl for the object, they will be in the same order as they were
            ' originally.  Just a positive side affect of addin items or a LIFO
            ' (Last In First Out) type list'
            InheritedDacl.AddAce ace
        Else
            ' We have an Implicit Ace, lets put it in the proper pool
            Select Case ace.AceType
                Case ADS_ACETYPE_ACCESS_ALLOWED
                    ImpAllowDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED
                    ImpDenyDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_ALLOWED_OBJECT
                    ImpAllowObjectDacl.AddAce ace
                Case ADS_ACETYPE_ACCESS_DENIED_OBJECT
                    ImpDenyObjectDacl.AddAce ace
                Case Else
                    'Bad Ace, but let's just leave it out for now.
            End Select
        End If
    Next
    '
    ' Combine the ACEs in the Proper Order
    '   Implicit Deny
    '   Implicit Deny Object
    '   Implicit Allow
    '   Implicit Allow Object
    '   Inherited ACEs
    '
    
    ' Implicit Deny
        For Each ace In ImpDenyDacl
            newDACL.AddAce ace
        Next
        
    ' Implicit Deny Object
        For Each ace In ImpDenyObjectDacl
            newDACL.AddAce ace
        Next
        
    ' Implicit Allow
        For Each ace In ImpAllowDacl
            newDACL.AddAce ace
        Next
        
    ' Implicit Allow Object
        For Each ace In ImpAllowObjectDacl
            newDACL.AddAce ace
        Next
        
    ' Inherited ACEs
        For Each ace In InheritedDacl
            newDACL.AddAce ace
        Next
    
    'Set the Appropriate revision level for the DACL
    newDACL.AclRevision = objDACL.AclRevision
    
    ' Return Properly Ordered DACL
    Set ReorderACL = newDACL
    
    ' Kill Objects
    Set newDACL = Nothing
    Set InheritedDacl = Nothing
    Set ImpAllowObjectDacl = Nothing
    Set ImpAllowDacl = Nothing
    Set ImpDenyObjectDacl = Nothing
    Set ImpDenyDacl = Nothing
    Set objSD = Nothing
    
End Function


'********************************************************************
'*
'* Function DetailError(detailedError)
'* Purpose: Fire a Fatal Error to the screen and stop further proccessing
'* Input:       detailedError   Text Message to display on the Screen (String)
'*
'* Output:  None
'*
'********************************************************************
Function DetailError(detailedError)
'//Dim ErrResponseString, descErr
'//    If Err.Number <> 0 Then
'//        descErr = Err.Description
'//
'//        If Write_Debug Then
'//            List1.AddItem "General Error: "
'//            List1.AddItem detailedError
'//            List1.AddItem "Description: " & descErr
'//            List1.AddItem "Number: " & Err.Number
'//        Else
'//            '//ErrResponseString = "Error.asp?Number=" & Err.Number & "&rndnum=" & rndnum & "&detailedError=" & detailedError & "&Descrip=" & descErr
'//            List1.AddItem ErrResponseString
'//
'/
'//        End If
'//    End If
End Function


'********************************************************************
'*
'* Function ParseUsernameFromADSPath(sAdsPath)
'* Purpose: Get/Return the UPN name from the AdsPath
'* Input:       g_OU        User Ads Path(String)
'*
'* Output:      String - user UPN
'*
'********************************************************************
Function ParseUsernameFromADSPath(sAdsPath)
    Dim OULoc
    OULoc = InStr(1, UCase(sAdsPath), "OU=")
    ' if there was no OU found, then look for some of the other
    '   builtin containers
    If OULoc = 0 Then
        OULoc = InStr(1, UCase(sAdsPath), "CN=USERS")
    End If
    If OULoc = 0 Then
        OULoc = InStr(1, UCase(sAdsPath), "CN=COMPUTERS")
    End If
    If OULoc = 0 Then
        OULoc = InStr(1, UCase(sAdsPath), "CN=BUILTIN")
    End If
    ParseUsernameFromADSPath = Mid(sAdsPath, 11, OULoc - 12)
End Function




